import React, { Component } from 'react';
import { Link } from 'react-router-dom';

class DetailTop extends Component {
  render() {
    const { projectDetail } = this.props;
    const { projectsId } = this.props.match.params;
    const { pathname } = this.props.location;
    return (
      <p className="branch-wrapper">
        <Link to={`/projects/${projectsId}/coders/commit`} className={pathname.indexOf("/coders/commit") > 0 ? "active" : ""}>
          <i className="iconfont icon-tijiaojilu font-20 mr3 font-bd"></i>
          <span>{projectDetail && projectDetail.commits_count}</span>个提交
        </Link>
        <Link to={`/projects/${projectsId}/coders/branch`} className={pathname.indexOf("/coders/branch") > 0 ? "active" : ""}>
          <i className="iconfont icon-fenzhi1 font-18 mr3"></i>
          <span>{projectDetail && projectDetail.branches_count}</span>个分支
        </Link>
        <Link to={`/projects/${projectsId}/coders/tag`} className={pathname.indexOf("/coders/tag") > 0 ? "active" : ""}>
          <i className="iconfont icon-biaoqian3 font-18 mr3"></i>
          <span>{projectDetail && projectDetail.issue_tags_count}</span>个标签
        </Link>
        <Link to={`/projects/${projectsId}/coders/version`} className={pathname.indexOf("/coders/version") > 0 ? "active" : ""}>
          <i className="iconfont icon-fahangban font-18 mr3"></i>
          <span>{projectDetail && projectDetail.version_releasesed_count}</span>个发行版
        </Link>
        {/* <Link to={`/projects/${projectsId}/coders/contributor`} className={pathname.indexOf("/coders/contributor") > 0 ? "active" : ""}>
          <i className="iconfont icon-gongxianzhe font-18 mr3"></i>
          <span>{projectDetail && projectDetail.contributor_users_count}</span>位贡献者
        </Link> */}
        <a href="javscript:void(0)" style={{cursor:"default"}}>
          <i className="iconfont icon-cangku font-18 mr3"></i>
          仓库 <span className="ml3">{projectDetail && projectDetail.size}</span>
        </a>
      </p>
    )
  }
}
export default DetailTop;
